#include <stdio.h>

#include "headers/bmp_constants.h"
#include "headers/util.h"

enum open_status open_read(const char *filename, FILE **file) {
    *file = fopen(filename, "rb");
    if (!*file) {
        return OPEN_ERROR;
    }
    return OPEN_OK;
}

enum open_status open_write(const char *filename, FILE **file) {
    *file = fopen(filename, "wb");
    if (!*file) {
        return OPEN_ERROR;
    }
    return OPEN_OK;
}

enum close_status close(FILE **file){
    if (fclose(*file) != 0) {
        return CLOSE_ERROR;
    }
    return CLOSE_OK;
}

int padding_calc(uint32_t width){
    int row_size = width * BMP_BYTES_PER_PIXEL;
    return (4 - (row_size % 4)) % 4;

    // row_size % 4 - число байтов, которых не хватает до ближайшего кратного 4
    // 4 - .. - кол-во байтов, которые нужно добавить, чтобы стало кратно
    // .. % 4 - гарантия, что результат от 0 до 3
}
